'NK DS Clock Kathode @ 22.12.92 [2014]

$regfile = "m8def.dat"
$crystal = 4000000
$hwstack = 64
$swstack = 64
$framesize = 64
$lib "ds1307clock.lib"


'I/O
'Come Anodes 1 2 3 4
Config Pind.0 = Output                                      '1000
Config Pind.6 = Output                                      '0200
Config Pind.7 = Output                                      '0030
Config Pind.5 = Output                                      '0004

'Segments a b c d e f g
Config Pind.1 = Output                                      'a
Config Pinb.0 = Output                                      'b
Config Pinb.2 = Output                                      'c
Config Pinb.4 = Output                                      'd
Config Pinb.5 = Output                                      'e
Config Pind.2 = Output                                      'f
Config Pinb.1 = Output                                      'g

'Second Blinking
Config Pinb.3 = Output                                      'With3,4 (0034)
Config Pind.3 = Input                                       'Hour Key
Config Pind.4 = Input                                       'Minute Key
ddrb.6 = 0 'AL set Key
ddrb.7 = 1 'buzzer

'Set Pullup Resistor For Setting Key's
Set Portd.3
Set Portd.4
portb.6 = 1
portb.7 = 0

'Aliases
'Dataport Alias Portd
'Comm Alias Portc
Hour_key Alias Pind.3
Min_key Alias Pind.4
Bk_sec Alias Portb.3
al_key alias pinb.6
alarm alias portb.7

Seg_a Alias Portd.1
Seg_b Alias Portb.0
Seg_c Alias Portb.2
Seg_d Alias Portb.4
Seg_e Alias Portb.5
Seg_f Alias Portd.2
Seg_g Alias Portb.1

Comm_1 Alias Portd.0
Comm_2 Alias Portd.6
Comm_3 Alias Portd.7
Comm_4 Alias Portd.5



Config Sda = Portc.5
Config Scl = Portc.4

'address of ds1307
Const Ds1307w = &HD0                         'Addresses of Ds1307 clock
Const Ds1307r = &HD1

Config Clock = User

'dim other needed variables
Dim Weekday As Byte


'Variables
Dim A As Byte , Dp As Bit
Dim Tmp As Byte
dim al_hour as  Byte, al_min as Byte
dim al_hour_save as ERAM Byte, al_min_save as ERAM Byte





'Declaration
Declare Sub Refresh
Declare Sub Send
Declare Sub Blink_sec
Declare Sub Rst7
Declare Sub Rst

alarm = 1
waitms 100
alarm = 0

'Reset Default
If hour_key = 0 and min_key = 0 Then

   al_hour_save = 1 : waitms 10
   al_min_save = 0 :waitms 10

   Time$ = "12:00:00"                        ' to watch the day changing value
   Date$ = "06-03-13"                        ' 08 june 2010

   '*********************************** for kathode **************************
   seg_a = 1
   '*********************************** for anode ****************************
   '(
   Comm_1 = 1
   Comm_2 = 1
   Comm_3 = 1
   Comm_4 = 1

   Seg_a = 0
   Seg_b = 1
   Seg_c = 1
   Seg_d = 1
   Seg_e = 1
   Seg_f = 1
   Seg_g = 1
   Bk_sec= 1
   ')
   '******************

   while hour_key = 0
   wend
   wait 1
End If

'loading
al_hour=al_hour_save : waitms 10
al_min=al_min_save : waitms 10

'Timer
Config Timer1 = Timer , Prescale = 64
Enable Interrupts
Enable Timer1
'3036
Timer1 = 3017
Start Timer1
On Ovf1 Ov1


'Main Prog Start Here:
Do
   Call Send
   '********** Key ***********
  if al_key = 1 then
   If Hour_key = 0 Then
      Incr _Hour
      If _Hour > 23 Then _Hour = 0
      Gosub Settime
      For Tmp = 1 To 20
         Call Send
      Next Tmp
   End If
   If Min_key = 0 Then
      Incr _Min
      If _Min > 59 Then _Min = 0
      Gosub Settime
      For Tmp = 1 To 20
         Call Send
      Next Tmp
   End If
  else 'al_key pressed:
   If Hour_key = 0 Then
      Incr al_hour
      If al_hour > 23 Then al_hour = 0
      al_hour_save = al_hour : waitms 10
      For Tmp = 1 To 20
         Call Send
      Next Tmp
   End If
   If Min_key = 0 Then
      Incr al_min
      If al_min > 59 Then al_min = 0
      al_min_save = al_min : waitms 10
      For Tmp = 1 To 20
         Call Send
      Next Tmp
   End If
  end if
Loop
End

   'Call Keyscan
   'Call Refresh
   'Call Blink_sec
'Loop
'End


Sub Refresh
Call Rst7
Select Case A
Case 0:
   Seg_a = 1
   Seg_b = 1
   Seg_c = 1
   Seg_d = 1
   Seg_e = 1
   Seg_f = 1
   'Seg_g = 1
Case 1:
   'Seg_a = 1
   Seg_b = 1
   Seg_c = 1
   'Seg_d = 1
   'Seg_e = 1
   'Seg_f = 1
   'Seg_g = 1
Case 2:
   Seg_a = 1
   Seg_b = 1
   'Seg_c = 1
   Seg_d = 1
   Seg_e = 1
   'Seg_f = 1
   Seg_g = 1
Case 3:
   Seg_a = 1
   Seg_b = 1
   Seg_c = 1
   Seg_d = 1
   'Seg_e = 1
   'Seg_f = 1
   Seg_g = 1
Case 4:
   'Seg_a = 1
   Seg_b = 1
   Seg_c = 1
   'Seg_d = 1
   'Seg_e = 1
   Seg_f = 1
   Seg_g = 1
Case 5:
   Seg_a = 1
   'Seg_b = 1
   Seg_c = 1
   Seg_d = 1
   'Seg_e = 1
   Seg_f = 1
   Seg_g = 1
Case 6:
   Seg_a = 1
   'Seg_b = 1
   Seg_c = 1
   Seg_d = 1
   Seg_e = 1
   Seg_f = 1
   Seg_g = 1
Case 7:
   Seg_a = 1
   Seg_b = 1
   Seg_c = 1
   'Seg_d = 1
   'Seg_e = 1
   'Seg_f = 1
   'Seg_g = 1
Case 8:
   Seg_a = 1
   Seg_b = 1
   Seg_c = 1
   Seg_d = 1
   Seg_e = 1
   Seg_f = 1
   Seg_g = 1
Case 9:
   Seg_a = 1
   Seg_b = 1
   Seg_c = 1
   Seg_d = 1
   'Seg_e = 1
   Seg_f = 1
   Seg_g = 1
'Case Else : Goto Main
End Select
   If Dp = 1 Then
      If Timer1 > 0 And Timer1 < 31260 Then Bk_sec = 1
      'Bk_sec = S
    Else
      Bk_sec = 0
   End If

   'alarm
   if al_min = _min and al_hour = _hour then
      If Timer1 > 0 And Timer1 < 31260 Then
         alarm = 1
      else
         alarm = 0
      end if
    else
     alarm = 0
   end if

Waitms 4
Call Rst7                                                   'Clear Screen
End Sub


Sub Rst
   Set Comm_1
   Set Comm_2
   Set Comm_3
   Set Comm_4
End Sub

Sub Rst7
   Reset Seg_a
   Reset Seg_b
   Reset Seg_c
   Reset Seg_d
   Reset Seg_e
   Reset Seg_f
   Reset Seg_g
   Reset Bk_sec
End Sub

Sub Send
   if al_key = 1 then
      Gosub Getdatetime
      Call Rst : Reset Comm_1 : Dp = 0 : A = _Hour \ 10 : Call Refresh
      Call Rst : Reset Comm_2 : Dp = 1 : A = _Hour Mod 10 : Call Refresh
      Call Rst : Reset Comm_3 : Dp = 0 : A = _Min \ 10 : Call Refresh
      Call Rst : Reset Comm_4 : Dp = 0 : A = _Min Mod 10 : Call Refresh
   else
      Call Rst : Reset Comm_1 : Dp = 0 : A = al_hour \ 10 : Call Refresh
      Call Rst : Reset Comm_2 : Dp = 1 : A = al_hour Mod 10 : Call Refresh
      Call Rst : Reset Comm_3 : Dp = 0 : A = al_min \ 10 : Call Refresh
      Call Rst : Reset Comm_4 : Dp = 0 : A = al_min Mod 10 : Call Refresh
   end if
End Sub

Ov1:
Timer1 = 3017
Return

'called from ds1307clock.lib
Getdatetime:
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 0                                                ' start address in 1307

  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307r                                          ' send address
  I2crbyte _sec , Ack
  I2crbyte _min , Ack                                       ' MINUTES
  I2crbyte _hour , Ack                                      ' Hours
  I2crbyte Weekday , Ack                                    ' Day of Week
  I2crbyte _day , Ack                                       ' Day of Month
  I2crbyte _month , Ack                                     ' Month of Year
  I2crbyte _year , Nack                                     ' Year
  I2cstop
  _sec = Makedec(_sec) : _min = Makedec(_min) : _hour = Makedec(_hour)
  _day = Makedec(_day) : _month = Makedec(_month) : _year = Makedec(_year)
Return

Setdate:
  _day = Makebcd(_day) : _month = Makebcd(_month) : _year = Makebcd(_year)
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 4                                                ' starting address in 1307
  I2cwbyte _day                                             ' Send Data to SECONDS
  I2cwbyte _month                                           ' MINUTES
  I2cwbyte _year                                            ' Hours
  I2cstop
Return

Settime:
  _sec = Makebcd(_sec) : _min = Makebcd(_min) : _hour = Makebcd(_hour)
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 0                                                ' starting address in 1307
  I2cwbyte _sec                                             ' Send Data to SECONDS
  I2cwbyte _min                                             ' MINUTES
  I2cwbyte _hour                                            ' Hours
  I2cstop
Return
'_______________________________________________________________________________